
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>数据结构——二叉树遍历之“递归与非递归遍历” / 憋错料</title>

    <meta name="description" content="数据结构——二叉树遍历之“递归与非递归遍历” 简述 二叉树的遍历分为先序遍历.中序遍历和后序遍历.如下图所示: 递归遍历 private void bianli1(List&lt;Integer&gt; list, TreeNode root) { // 先序遍历 if (root == null) { return; } list.add(root.val); bianli1(list, root.left); bianli1(list, root.right); } private void bianli2(List&lt;Intege ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">数据结构——二叉树遍历之“递归与非递归遍历”</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2>简述</h2>
<p>二叉树的遍历分为先序遍历、中序遍历和后序遍历。如下图所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzczMTcxNi8yMDE3MDMvNzMxNzE2LTIwMTcwMzE3MjE1MzM1OTYzLTY5Nzc2OTYyMS5wbmc=.jpg" /></p>
<h2>递归遍历</h2>

<pre>private void bianli1(List&lt;Integer&gt; list, TreeNode root) {
    // 先序遍历
    if (root == null) {
        return;
    }
    list.add(root.val);
    bianli1(list, root.left);
    bianli1(list, root.right);
}

private void bianli2(List&lt;Integer&gt; list, TreeNode root) {
    // 中序遍历
    if (root == null) {
        return;
    }
    bianli2(list, root.left);
    list.add(root.val);
    bianli2(list, root.right);
}

private void bianli3(List&lt;Integer&gt; list, TreeNode root) {
    // 后序遍历
    if (root == null) {
        return;
    }
    bianli3(list, root.left);
    bianli3(list, root.right);
    list.add(root.val);
}</pre>
<p>递归遍历实现比较简单，递归利用函数栈来保存信息。</p>
<h2>非递归遍历</h2>
<p>非递归需要额外自己申请数据结构来代替函数栈。</p>
<h3>先序遍历：</h3>
<p>1.申请一个栈 stack。然后将头结点 head 压入 stack 中。<br />	2.从 stack 中弹出栈顶结点，记为 cur，然后打印 cur 结点的值，再将 cur 的右孩子（非空的话）和左孩子（非空的话）分别压入栈中。<br />	3.不断重复步骤 2，直到栈 stack 为空，全部过程结束。</p>
<h3>中序遍历：</h3>
<p>1.申请一个栈 stack。初始时，令变量 cur=head。<br />	2.先把 cur 结点压入栈中，然后依次把左边界压入栈中，即不停的令 cur=cur.left，重复该步骤。<br />	3.不断重复步骤 2，直到 cur 为空为止，此时从 stack 中弹出栈顶元素，记为 node。打印 node 的值，并将 cur=node.right，然后继续重复步骤2。<br />	4.当 stack 为空且 cur 为空时，整个过程停止。</p>
<h3>后序遍历：</h3>
<p>1.申请一个栈，记为s1，然后将头结点 head 压入 s1 中。<br />	2.从 s1 中弹出的结点记为 cur，然后依次将 cur 的左孩子和右孩子压入 s1 中。<br />	3.整个过程中 s1 所弹出的结点都压入 s2 中。<br />	4.不断重复步骤2-3，直到 s1 为空为止。<br />	5.从 s2 中弹出结点并打印，打印的顺序就是后序遍历的顺序。</p>
<h3>源码实现：</h3>

<pre>/**
 * 先序遍历
 */
private static void xianxu(List&lt;Integer&gt; list, TreeNode root) {
    Stack&lt;TreeNode&gt; stack = new Stack&lt;TreeNode&gt;();
    stack.add(root);
    while (!stack.isEmpty()) {
        root = stack.pop();
        list.add(root.val);
        if (root.right != null) {
            stack.push(root.right);
        }
        if (root.left != null){
            stack.push(root.left);
        }

    }
}
/**
 * 中序遍历
 */
private static void zhongxu(List&lt;Integer&gt; list, TreeNode root) {
    Stack&lt;TreeNode&gt; stack = new Stack&lt;TreeNode&gt;();
    while (!stack.isEmpty() || root!=null) {
        if (root != null) {
            stack.push(root);
            root = root.left;
        }else {
            root = stack.pop();
            list.add(root.val);
            root = root.right;
        }
    }
}
/**
 * 后序遍历
 */
private static void houxu(List&lt;Integer&gt; list, TreeNode root) {
    Stack&lt;TreeNode&gt; stack1 = new Stack&lt;TreeNode&gt;();
    Stack&lt;TreeNode&gt; stack2 = new Stack&lt;TreeNode&gt;();
    stack1.add(root);
    while (!stack1.isEmpty()) {
        root = stack1.pop();
        stack2.push(root);
        if (root.left != null) {
            stack1.push(root.left);
        }
        if (root.right != null) {
            stack1.push(root.right);
        }
    }
    while (!stack2.isEmpty()) {
        list.add(stack2.pop().val);
    }
}</pre>

<h2>参考资料</h2>
<p>[1] 程序员代码面试, 第三章 - 二叉树问题</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 10:01:44 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e6%8a%80%e6%9c%af%e5%88%86%e4%ba%ab/" title="技术分享">技术分享</a>, <a href="https://www.biecuoliao.com/tag/class/" title="class">class</a>, <a href="https://www.biecuoliao.com/tag/bsp/" title="bsp">bsp</a>, <a href="https://www.biecuoliao.com/tag/ati/" title="ati">ati</a>, <a href="https://www.biecuoliao.com/tag/%e6%af%94%e8%be%83/" title="比较">比较</a>, <a href="https://www.biecuoliao.com/tag/%e9%81%8d%e5%8e%86/" title="遍历">遍历</a>, <a href="https://www.biecuoliao.com/tag/block/" title="block">block</a>, <a href="https://www.biecuoliao.com/tag/%e9%9d%a2%e8%af%95/" title="面试">面试</a>, <a href="https://www.biecuoliao.com/tag/%e5%90%8e%e5%ba%8f%e9%81%8d%e5%8e%86/" title="后序遍历">后序遍历</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>数据结构——二叉树遍历之“递归与非递归遍历”的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JbrbV4.html" rel="bookmark">数据结构二叉树的递归与非递归遍历之 实现可编译（1）java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前一段时间,学习数据结构的各种算法,概念不难理解,只是被C++的指针给弄的犯糊涂,于是用java,web,javascript,分别去实现数据结构的各种算法. 二叉树的遍历,本分享只是以二叉树中的先序遍历为例进行说明,中序遍历和后序遍历,以此类推! 二叉树递归与非递归遍历的区别,虽然递归遍历,跟容易读懂,代码量少,运算快,但是却容易出现溢出的问题,所以所以非递归遍历,在处理千万级的运算量时会先的很有用处. 二叉树的先序遍历:先访问根节点,再访问先后访问左右节点.如图: 二叉树的递归遍历之java			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDR2J93.html" rel="bookmark">Java数据结构系列之&mdash;&mdash;树（4）：二叉树的中序遍历的递归与非递归实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				package tree.binarytree; import java.util.Stack; /** * 二叉树的中序遍历:递归与非递归实现 * * @author wl * */ public class BiTreeInOrder { // 中序遍历的递归实现 public static void biTreeInOrderByRecursion(BiTreeNode root) { if (root == null) { return; } biTreeInOrderByRecursi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KvWoLM.html" rel="bookmark">Java数据结构系列之&mdash;&mdash;树（5）：二叉树的后序遍历的递归与非递归实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				package tree.binarytree; import java.util.Stack; /** * 二叉树后序遍历的递归与非递归实现 * * @author wl * */ public class BitreePostOrder { // 后序遍历的递归实现 public static void biTreePostOrderByRecursion(BiTreeNode root) { if (root == null) { return; } biTreePostOrderByRe			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kpzrb3.html" rel="bookmark">二叉树的前序、中序、后序遍历（递归、非递归）实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文部分来源于CSDN兰亭风雨大牛的原创.链接为http://blog.csdn.net/ns_code/article/details/12977901 二叉树是一种非常重要的数据结构,很多其他数据机构都是基于二叉树的基础演变过来的.二叉树有前.中.后三种遍历方式,因为树的本身就是用递归定义的,因此采用递归的方法实现三种遍历,不仅代码简洁且容易理解,但其开销也比较大,而若采用非递归方法实现三种遍历,则要用栈来模拟实现(递归也是用栈实现的).下面先简要介绍三种遍历方式的递归实现,再详细介绍三种遍			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPO5Pz4.html" rel="bookmark">C实现二叉树（模块化集成，遍历的递归与非递归实现）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C实现二叉树模块化集成 实验源码介绍(源代码的总体介绍):header.h : 头文件链栈,循环队列,二叉树的结构声明和相关函数的声明.LinkStack.c : 链栈的相关操作函数定义.Queue.c : 循环队列的相关操作函数定义.BinTree.c : 二叉树的相关操作的函数定义,层序序列生成二叉树,二叉树的前序序列.中序序列.后序序列的递归和非递归实现,求叶子结点的递归与非递归实现,求树高.我目前还是新手且第一次写类似的博客,文章中难免会有错误!如发现错误,望各路大神能够指出!详见源代码			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Q3qlNa0.html" rel="bookmark">JAVA递归、非递归遍历二叉树（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文链接: JAVA递归.非递归遍历二叉树 import java.util.Stack; import java.util.HashMap; public class BinTree { private char date; private BinTree lchild; private BinTree rchild; public BinTree(char c) { date = c; } // 先序遍历递归 public static void preOrder(BinTree t) {			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgLw9N0.html" rel="bookmark">二叉树遍历递归与非递归实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				说明:本文仅供学习交流,转载请标明出处,欢迎转载! 二叉树遍历是二叉树中非常基础的部分,也是学习二叉树必须熟练掌握的部分,下面我们先给出二叉树三种遍历方式的定义,并通过举例来说明二叉树遍历的过程. 二叉树的遍历分为:前序遍历(也叫先序遍历).中序遍历.后序遍历.所谓前.中.后都是根据当前子树根结点相对左右孩子的位置而言,也就是说: 前序遍历:根结点在前,即:根 -----&gt;左-------&gt;右: 中序遍历:根结点在中间,即:左------&gt;根------&gt;右: 后序遍历:根结点在最			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35VomR4.html" rel="bookmark">二叉树三种遍历（递归以及非递归实现）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				package com.shiyeqiang.tree; import java.util.Stack; public class BiTree { public static void main(String[] args) { // 首先构造叶子节点 BiTree leafA1 = new BiTree(4); BiTree leafA2 = new BiTree(5); BiTree leafB1 = new BiTree(6); BiTree leafB2 = new BiTree(7)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEkzwy3.html" rel="bookmark">二叉树遍历算法总结（递归与非递归）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一:前言 二叉树的遍历方法分四种:前序,中序,后序以及层次遍历. 其中,前中后遍历方法的实现分递归和非递归,非递归遍历的实现需要借助于栈. 实际上,递归的调用就是一种栈的实现,所以,非递归遍历就需要人工借助栈结构来实现. 而层次遍历需要借助队列. 二:前中后序遍历 递归遍历: 递归遍历的思想和方法很简单,通过调整输出语句来实现前,中,后三种遍历. 代码如下: 1 void show(BiTree T) 2 { 3 if(T) 4 { 5 printf(&quot;%c &quot;,T-&gt;data)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kDvGX3.html" rel="bookmark">二叉树递归与非递归遍历，最近公共父节点算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				#include &lt;iostream&gt; #include &lt;stack&gt; using namespace std; #define MAX 100 //字符串最大长度 typedef struct Node //二叉树结点 { char data; Node *lchild,*rchild; } *Btree; void createBT(Btree &amp;t); //先序构造二叉树 void preorder(Btree &amp;t); //二叉树递归先序遍历 void i			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V0bjBv0.html" rel="bookmark" class="title">Mysql性能调优</a>
					<div>
						1. 宏观上调优可以考虑三个部分,分别为硬件.网络.软件,此处主要考虑软件调优 (1)软件调优包括:表设计(范式.字段类型.数据存储引擎).SQL语句语索引.配置文件参数.文件系统.操作系统.MYSQ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0xEBL3.html" rel="bookmark" class="title">linux  odbc连接sql server2014</a>
					<div>
						首先坑爹呀!由于配置Zabbix 用到这个,网上资料一顿搜,一顿报错,调各种参数,依然无法连接,我竟无言以对: 这个只是项目的一小部分,只提供成功案例,没做深入研究,可以让遇到的兄弟少走弯路: 首先要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDRvKK3.html" rel="bookmark" class="title">python之函数用法startswith&lpar;&rpar;</a>
					<div>
						# -*- coding: utf-8 -*- #python 27 #xiaodeng #python之函数用法startswith() #http://www.runoob.com/python/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDZGQ93.html" rel="bookmark" class="title">Shell（C&plus;&plus;实现，CodeBlocks&plus;GCC编译）</a>
					<div>
						//main.cpp 1 #include &lt;iostream&gt; 2 #include &quot;shell.h&quot; 3 using namespace std; 4 int c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz5QEA4.html" rel="bookmark" class="title">SharePoint Server 2016 Update</a>
					<div>
						Today’s post was written by Seth Patton, senior director of product management for the SharePoint te ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l5wgB3.html" rel="bookmark" class="title">mysql开启慢查询方法</a>
					<div>
						1,配置开启 Linux: 在mysql配置文件my.cnf中增加 log-slow-queries=/var/lib/mysql/slowquery.log (指定日志文件存放位置,可以为空,系统会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgPkzp0.html" rel="bookmark" class="title">python学习：字符串操作</a>
					<div>
						1:双引号转义 &lt;span style=&quot;font-size:18px;&quot;&gt;&lt;strong&gt;print &quot;he\&quot;llo&quot;&l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xvRBQ4.html" rel="bookmark" class="title">PL&sol;0 词法分析器</a>
					<div>
						1 #include&lt;stdio.h&gt; 2 #include &lt;ctype.h&gt; 3 #include &lt;stdlib.h&gt; 4 #include &lt;stri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bq6zwM.html" rel="bookmark" class="title">mybatis &plus; postgresql 遇到的问题</a>
					<div>
						org.postgresql.util.PSQLException: ERROR: relation &quot;circlefence&quot; does not exist 这个问题是数据库表没 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZmOb3.html" rel="bookmark" class="title">java Annotation Demo</a>
					<div>
						Java 1.5引入了annotation,这个功能非常好用,是用c#等语言借鉴过来的一个特性. 首先编译器本身支持一些像overrides,supresswarning之类的注解. Spring,j ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmYompM.html" rel="bookmark" class="title">Linux系统安装tomcat</a>
					<div>
						1.首先下载tomcat:http://tomcat.apache.org/download-60.cgi 2.解压缩tar.gz文件: tar -xzvf xxxxxxx/apache-tomcat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lkaREM.html" rel="bookmark" class="title">关于python中的IO流</a>
					<div>
						只要有IO,那么就会发生IOError.所以尽量每次都要使用try...finally #!/usr/bin/env python #-*-coding:utf-8-*- try: f=open(&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xB6rQ4.html" rel="bookmark" class="title">&lbrack;dubbo&rsqb; dubbo 基础使用</a>
					<div>
						Dubbo是一个分布式服务框架,致力于提供高性能和透明化的RPC远程服务调用方案,以及SOA服务治理方案.简单的说,dubbo就是个服务框架,如果没有分布式的需求,其实是不需要用的,只有在分布式的时候 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MobKYy4.html" rel="bookmark" class="title">ios6如何处理内存，分别为前警告后</a>
					<div>
						这里有一篇文章.非常具体地说明了ios6前后是怎样处理内存警告的: 来自唐巧的技术博客:http://blog.devtang.com/blog/2013/05/18/goodbye-viewdidu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KjoDwM.html" rel="bookmark" class="title">linux消息队列的使用及内核实现原理</a>
					<div>
						mq_receive NAME mq_open - open a message queue SYNOPSIS #include &lt;fcntl.h&gt; /* For O_* constant ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmmpE1M.html" rel="bookmark" class="title">集群间心跳检测</a>
					<div>
						[皇室]杭州-sunface() 2015/11/23 星期一 上午 10:24:04 erl -kernel net_ticktime或者net_kernel:set_net_ticktime/1可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLxXeBM.html" rel="bookmark" class="title">不使用第三方组件，只调用COM，导出EXECL，但只装OFFICE2007，不装2003，直接强制引用动态库的方法</a>
					<div>
						步骤1:强制引用动态库”Microsoft.Office.Interop.Excel“,版本为11.0: 步骤2:添加引用OFFICE2007的COM组件”MicroSoft Office 12.0  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rQROa0.html" rel="bookmark" class="title">Spring初学之annotation实现AOP前置通知和后置通知</a>
					<div>
						实现两个整数的加减乘除,并在每个计算前后打印出日志. ArithmeticCalculator.java: package spring.aop.impl; public interface Arit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RQr8RM.html" rel="bookmark" class="title">（DT系列五）Linux kernel 是怎么将 devicetree中的内容生成plateform&lowbar;device</a>
					<div>
						Linux kernel 是怎么将 devicetree中的内容生成plateform_device 1,实现场景(以Versatile Express V2M为例说明其过程)以arch/arm/ma ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pDRBK4.html" rel="bookmark" class="title">ZCMU新人训练赛-B</a>
					<div>
						 Tom's Meadow Tom has a meadow in his garden. He divides it into N * M squares. Initially all the sq ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
